package gs.db;

import gs.db.update;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public abstract class database {

  public Hashtable fields;

  public database() 
  {
    fields = new Hashtable();
  }

  abstract public String getTableName();
  abstract public String getFieldNames();
  abstract public String getFieldValues();
  abstract public String getSetValues();


  public void openDB() throws Exception{ query.Open(); }
  public void closeDB()throws Exception { query.Close(); }
  public static void closeAll() { query.closeAll(); }
  public String insertSQL() 
  {
    return "INSERT INTO "+ getTableName() + " ("+ getFieldNames() +") "+
       "VALUES ("+ getFieldValues() +")";
  }
  
  public String updateSQL(String whereClause) 
  {
    return "UPDATE "+ getTableName()
      + " SET " + getSetValues()
      + " WHERE " + whereClause;
  }
  public  String updateFieldsSQL(String fields_values,String whereClause) 
  {
    return "UPDATE "+ getTableName()
      + " SET " + fields_values 
      + " WHERE " + whereClause;
  }

  public String deleteSQL(String whereClause) 
  {
    return "DELETE FROM "+ getTableName() 
      +" WHERE "+ whereClause;
  }

  public Hashtable getFields()
  {
    return fields;
  }

  public  ResultSet records(String proj, 
			   String where, 
			   String order) 
       throws Exception 
  {
    if(proj.equals("")) proj = "*";
    if(!where.equals("")) where = " WHERE " + where;
    if(!order.equals("")) order = " ORDER BY " + order;
    
    String queryString = "SELECT "+proj
      +" FROM "+ getTableName() + where + order;

    //System.out.println("queryString " +queryString +" ");
    ResultSet rs = null;
    try {
      rs = query.queryData( queryString );
    } catch(Exception e) {
      throw e; 
    }
    return rs;
  }

  public void updateAllTables(String updatestr)throws Exception {
    update.updateData( "UPDATE courses "+updatestr);
    update.updateData( "UPDATE questions "+updatestr);
    update.updateData( "UPDATE surveys "+updatestr);
    update.updateData( "UPDATE answers "+updatestr);
    update.updateData( "UPDATE students "+updatestr);
    update.updateData( "UPDATE customizedgrades "+updatestr);
    update.updateData( "UPDATE assignments "+updatestr);
    update.updateData( "UPDATE grades "+updatestr);
    update.updateData( "UPDATE performances "+updatestr);
  }


}
