package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbStudent;
import gs.db.dbSurvey;

import gs.admin.gSystem;
import gs.admin.gCourses;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;

import gs.conf.Configuration;

/**
 */
public class gServices extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  public gSystem  sys=new gSystem();



  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // doPost  doGet
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  
  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }

  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // processInOut
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 

    //System.out.println( "SERVICES");
    if (command==null) {
      return;
    }

    String request="";

    //System.out.println( "unum - - - > ["+unum+"]" );
    //System.out.println( "comm - - - > ["+command+"]" );
    try {
      if (unum==null ) 
	throw new Exception("State lost: Unknown cours or user!.");
      if (command.indexOf("System Services")>=0) {
	sys.accessPermission(unum,"ALL","SERVICE:"+command);
	serviceMenu(out, unum,req.getPathTranslated());
	return;
      }
      
      String course  = req.getParameter("course");
      //System.out.println( "course - - - > ["+course+"]" );
      if ( course==null ) {
	String coursename  = req.getParameter("coursename");

	if (coursename==null ||unum==null ) 
	  throw new Exception("State lost: Unknown course or user!.");
	String term    = req.getParameter("term");
	String year    = req.getParameter("year");
	course=coursename+term+year;
      }

      sys.accessPermission(unum,course,"SERVICE:"+command);

      if(command.indexOf("Password Assignment")>=0) 
	//listServices(out, unum, course, req.getPathTranslated(), false);
	passwordAssignPage(out, unum, course, req.getPathTranslated());

      else if(command.equals("PREFERENCES"))
	systemSettings(out, unum, req.getPathTranslated(),req);
      else if(command.indexOf("Preferences")>=0)
	currentSettingsPage(out, unum, course, req.getPathTranslated());
      else if(command.equals("CHANGE"))
	passwordAssign(out, unum, course,req.getParameter("accesscode"),req.getParameter("systemslogin"), req.getParameter("systemspwd"),  req.getPathTranslated());
      else if(command.indexOf("Majordomo Subscription")>=0) 
	majordomoPage(out, unum, course, req.getPathTranslated());
      else if(command.indexOf("Backup")>=0) 
	backupPage(out, unum, course, req.getPathTranslated());
      else if(command.equals("SHOW"))
	browseService(out, unum, course, req.getPathTranslated(), req.getParameter("accesscode"),"don't reload");

      else if(command.equals("NEW"))
	newService(out, unum, course, req.getPathTranslated());


      else if(command.equals("SKIP"))
	skip(out, unum, course, req.getPathTranslated());

      else if(command.equals("INFO"))
	infoPage(out, unum, course, req.getPathTranslated());

      else if(command.equals("CANCEL")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
	//decideFrame(out, unum, req.getPathTranslated(), 
	//    "SHOW", 
	//    "browse.html", req.getParameter("oldaccesscode"));
      }
      else if(command.equals("EDIT"))
	editServiceRecord(out, unum, course, req.getPathTranslated(),
			  (String)(req.getParameter("accesscode")));


      else if(command.equals("DELETE"))
	deleteService(out, unum, course, req.getPathTranslated(),
		      (String)(req.getParameter("accesscode")), 
		      (String)(req.getParameter("answer")));

      else if(command.equals("UPDATE")) 
	updateService(out, unum, course, readServiceFields(req), req.getPathTranslated());

      else if(command.equals("ADD")) 
	addService(out, unum, course, readServiceFields(req) , req.getPathTranslated());

      else if(command.equals("BEFORELOGIN")) 
	serviceMenu(out, unum, req.getPathTranslated());
      //returnPublicPage(out, unum, course, req.getPathTranslated());
      //........................SERVICES.............................      

     
      else if(request.equals("ACCESS")) 
	accessPage(out, unum, course, req.getPathTranslated(),
		   (String)(req.getParameter("lgn")),(String)(req.getParameter("pwd")));
      else if(request.indexOf("Personal Info Access")>=0) 
	personalInfo(out, unum, course, req.getPathTranslated(),"don't reload");
      // personalInfo(out,req.getParameter("accesscode"), course, req.getPathTranslated(),"don't reload");
      else if(request.indexOf("Personal Info Access")>=0) 
	personalInfo(out, unum, course, req.getPathTranslated(),"don't reload");
      else if(request.indexOf("Personal Record Update")>=0) 
	personalRecordUpdate(out, unum, course, req.getPathTranslated());
      else if(request.equals("UPDATE")) {
	serviceUpdate(out, unum, course, readServiceFields(req), req.getPathTranslated());
      }
      else if(request.indexOf("Course Grades Access")>=0) 
	showGrades(out, unum, course, req.getPathTranslated());
      else if(request.indexOf("Password Change")>=0) 
	changePasswordPage(out, unum, course, req.getPathTranslated());
      else if(request.indexOf("Post Office")>=0) 
	postOffice(out, unum, course, req.getPathTranslated());
      else if(request.indexOf("Class List")>=0) 
	classList(out, unum, course, req.getPathTranslated());
      else if(request.equals("CHANGE"))
	changePassword(out, unum, course, req.getParameter("gspwd"), req.getPathTranslated());
      else if(request.indexOf("Course Survey")>=0) 
	surveyMenu(out, unum, course, req.getPathTranslated());
      else if(request.equals("FILL SURVEY"))
	surveyPage(out, unum, course, req.getPathTranslated(),req.getParameter("surveyname"));
      else if(request.equals("SURVEYCOMPLETE"))
	storeSurvey(out, unum, course,  req.getPathTranslated(),req.getParameter("surveyname"),req.getParameter("survey"));

    } catch (Exception e) {
       //System.out.println( "Error catched. " );
      //if (e.getMessage()!=null)
	 //System.out.println( e.getMessage());
       //System.out.println( "ERROR CATCHED. " );
      sys.error(out,e);
      // e.printStackTrace();
      // sys.error(out,e.getMessage());
     }
     
     //    out.println( Html.footer() );
     out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads Service fields from the html request form
  //--------------------------------------------------------------------//
  public dbStudent readServiceFields(HttpServletRequest req) throws Exception {

    dbStudent u=new dbStudent();

    String accesscode   = req.getParameter("accesscode"); 
    String firstname = req.getParameter("firstname"); 
    String midname   = req.getParameter("midname");
    String lastname  = req.getParameter("lastname"); 
    String gspwd     = req.getParameter("gspwd"); 
     String confirm   = req.getParameter("confirmgspwd"); 
      
    if(accesscode.equals("") || firstname.equals("") || lastname.equals("") 
       || gspwd.equals("") || confirm.equals("")) 
      throw new Exception("Please enter in all the fields in red!");
    else {
      u.fields.put("course"     , req.getParameter("course"));
      u.fields.put("idnum"     , req.getParameter("idnum"));
      u.fields.put("serviceid" , req.getParameter("serviceid"));
      u.fields.put("class"       , req.getParameter("class"));
      u.fields.put("email"     , req.getParameter("email")); 
      u.fields.put("dept"      , req.getParameter("dept")); 
      u.fields.put("url"       , req.getParameter("url"));  
      u.fields.put("picurl"    , req.getParameter("picurl"));  
      u.fields.put("systemslogin"   , req.getParameter("systemslogin"));
      u.fields.put("systemspwd"  , req.getParameter("systemspwd"));
      u.fields.put("oldaccesscode"  , req.getParameter("oldaccesscode"));
      
    }
    u.fields.put("accesscode"     , accesscode);    
    u.fields.put("firstname"   , firstname);    
    u.fields.put("midname"     , midname);    
    u.fields.put("lastname"    , lastname);    
    u.fields.put("gspwd"       , gspwd);    
    u.setIdentification();

    return u;

  }
 

 //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  void currentSettingsPage(ServletOutputStream out, String unum,String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Configuration.readConfiguration(ht);
      Parser.parseHtml(templateFile,ht , out);
  }

  //--------------------------------------------------------------------//
  //serviceMenu(
  //--------------------------------------------------------------------//  
  void serviceMenu(ServletOutputStream out, String unum, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht , out);
  }


  //--------------------------------------------------------------------//
  // List ALL services 
  //--------------------------------------------------------------------//  
  void listServices(ServletOutputStream out, String unum, String course, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      String fieldNames = "accesscode,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbStudent u = new dbStudent();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      ResultSet rs = u.records(queryProjection,"","lastname,firstname");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
   }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String course ,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      ht.put("course",course);
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }

  //--------------------------------------------------------------------//
  // Browse a service
  //--------------------------------------------------------------------//  
  void browseService (ServletOutputStream out, String unum,String course, String templateFile, String accesscode,String reload) 
       throws Exception, IOException
  {
    if(accesscode.length() >= 3 ){//gServices.MIN_LOGIN_NAME_LENGTH) {
      try {
	//Hashtable ht=dbStudent.getFields( accesscode );
	Hashtable ht=sys.std_cache.get(accesscode,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course);
	ht.put("reload",reload);
	Parser.parseHtml(templateFile,ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing service "+accesscode+": "+e.getMessage()+"</h2>");
      }
    } else {
      throw new Exception("<h2>ERROR:Illegal service login name '"+accesscode+"'.</h2>");
    }
  }

  //--------------------------------------------------------------------//
  // open new service page 
  //--------------------------------------------------------------------//  
  void newService  (ServletOutputStream out, String unum,String course, String templateDir)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateDir+"new.html", ht, out);
  }


   //--------------------------------------------------------------------//
  //  editServiceRecord page
  //--------------------------------------------------------------------//  
  void editServiceRecord (ServletOutputStream out, String unum,String course, 
		      String templateDir, String accesscode)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.get(accesscode,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    ht.put("accesscode", accesscode);
    ht.put("oldaccesscode", accesscode);

    Parser.parseHtml(templateDir+"edit.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // DELETE a service
  //--------------------------------------------------------------------//  
  void deleteService (ServletOutputStream out, String unum,String course,
		   String templateDir, String accesscode, String answer) 
       throws Exception, IOException
  {
    String templateFile=templateDir;;
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if(answer == null) {

	templateFile+="confirm.html";
	ht.put("message", "<br>Do you really want to delete the service <i>"+accesscode+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
      ht.put("course",course);
	ht.put("accesscode",accesscode);
      } 
      else if(answer.equals("YES")) {
	//dbStudent.delete(accesscode);
	sys.std_cache.delete(accesscode,course);
	ht.put("message", "Service information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new Service
  //--------------------------------------------------------------------//  
  void addService(ServletOutputStream out, String unum,String course, dbStudent dbu, String templateDir )
       throws Exception,IOException
  {
    try {
      //dbu.add();
      sys.std_cache.add(dbu);
      browseService(out, unum,course,templateDir+"browse.html",dbu.accesscode,"reload");
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This service login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update service record 
  //--------------------------------------------------------------------//  

  void updateService(ServletOutputStream out, String unum,String course, dbStudent dbu,String templateDir)
       throws Exception,IOException
    {
      try {
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	//	dbu.update();
	sys.std_cache.update(dbu);
      browseService(out, unum,course,templateDir+"browse.html",dbu.accesscode,"reload");
	
      } catch( Exception e ) {
	out.println( Html.header("Service Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This service login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String course,String templateDir) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
	ht.put("course",course);
      Parser.parseHtml(templateDir+"info.html",ht,out);
  }

  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void accessPage (ServletOutputStream out, String unum,String course, String templateDir,String accesscode, String gspwd)
       throws Exception, IOException 
  {
    String templateFile=templateDir;
    Hashtable ht=new Hashtable();

     //System.out.println("Check the User Autr ---->>>>>:" +accesscode+gspwd+", kors:"+course);

     try {
       unum=sys.std_cache.accessCheck(course,accesscode,gspwd,sys.DONTASKPWD);
       templateFile +="serviceMenu.html";
     } catch(Exception e) { 
        //System.out.println(e.getMessage());
       if (e.getMessage().indexOf("GS:")<0)
	 throw e;
       templateFile +="denied.html";
       unum="unknown";
     }
    sys.globalValues(ht,unum);
    ht.put("course",course);

//System.out.println("templateFile "+templateFile);
//System.out.println("unum "+(String)ht.get("unum"));

    Parser.parseHtml(templateFile,ht , out);
  }
  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
   void personalInfo (ServletOutputStream out, String unum,String course, String templateDir,String reload) 
       throws Exception, IOException
  {
    try {
      //Hashtable ht=sys.std_cache.findGet(unum).getFields();
	Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course);
	ht.put("reload",reload);
	Parser.parseHtml(templateDir+"browse.html",ht , out);
      
    } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing service "+unum+e.getMessage()+"</h2>");
    }
  
  }
  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
   //--------------------------------------------------------------------//
  //  editServiceRecord page
  //--------------------------------------------------------------------//  
  void personalRecordUpdate (ServletOutputStream out, String unum,String course, 
		      String templateDir)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    // ht.put("accesscode", accesscode);
    // ht.put("oldaccesscode", accesscode);

    Parser.parseHtml(templateDir+"edit.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void serviceUpdate(ServletOutputStream out, String unum,String course, dbStudent u,String templateDir)
       throws Exception,IOException
  {
    dbStudent old=sys.std_cache.getbyID(unum,course);
    u.fields.put("oldaccesscode"  , old.fields.get("accesscode" ));
    u.fields.put("accesscode"     , old.fields.get("accesscode" ));    
    u.fields.put("gspwd"       , old.fields.get("gspwd" ));    
    old.fields=u.fields;
   
    updateService(out, unum, course, old, templateDir);
  }
  //--------------------------------------------------------------------//  
  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void   showGrades(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

 //System.out.println("Please implement MEMMMEMMEMEMEM");

    Parser.parseHtml(templateDir+"grades.html", ht, out);

  }
  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void   postOffice(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

    //System.out.println("Please implement MEMMMEMMEMEMEM");
    
    dbStudent s=new dbStudent();
    String ofis= s.postOffice(course);
    // dbUser u =new dbUser();
    // ofis +=u.postOffice(course);
//System.out.println("ofis===?>"+ofis);
    ht.put("office",ofis);
    Parser.parseHtml(templateDir+"postOffice.html", ht, out);

  }
 //--------------------------------------------------------------------//
  // SERVICE backup
  //--------------------------------------------------------------------//  
  void   backupPage(ServletOutputStream out, String unum,String course,  String templateFile)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
  
    Parser.parseHtml(templateFile, ht, out);
 
  }  //--------------------------------------------------------------------//
  // SERVICE MAJORDOMO
  //--------------------------------------------------------------------//  
  void   majordomoPage(ServletOutputStream out, String unum,String course,  String templateFile)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
  
    dbStudent s=new dbStudent();
    String []email=new String[3];
    String d=s.majordomoList(course,email);

    ht.put("emails",email[0]);
    ht.put("noemail",email[2]);
     ht.put("nologin",email[1]);
   
    //System.out.println("Please impleCOURDS "+course+"dffsdfsdfsdf"+d);
 //    Parser.parseHtml(templateFile, ht, out,  new RecordParser( s.majordomoList(course),s.majordomoListFields(course)));
 
    Parser.parseHtml(templateFile, ht, out);
 
  }
  //--------------------------------------------------------------------//
  // SERVICE passwordAssignPage
  //--------------------------------------------------------------------//  
  void   passwordAssignPage(ServletOutputStream out, String unum,String course,  String templateFile)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

    //System.out.println("Please implement MEMMMEMMEMEMEM");
    
    //Parser.parseHtml(templateDir+"classList.html", ht, out);
    dbStudent s=new dbStudent();
    
    Parser.parseHtml(templateFile, ht, out,  new RecordParser( s.classPasswordList(course),s.classPasswordListFields(course)));
 
  }
  //--------------------------------------------------------------------//
  // SERVICE  passwordAssign
  //--------------------------------------------------------------------//  
  void   passwordAssign(ServletOutputStream out, String unum,String course,String accesscode, String systemslogin, String systemspwd  ,String templateFile)        
       throws  Exception, IOException
  {   
    Hashtable ht=new Hashtable(); //sys.std_cache.getbyID(unum).getFields();
 
     //change
    dbStudent s=new dbStudent();
    s.changePassword(accesscode,course,systemslogin,systemspwd);
    sys.std_cache.revert(accesscode,course);
    Parser.parseHtml(templateFile, ht, out);
 
  }

   //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void   classList(ServletOutputStream out, String unum,String course,  String templateDir)        
       throws  Exception, IOException
  {   
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);

    //System.out.println("Please implement MEMMMEMMEMEMEM");
    
    //Parser.parseHtml(templateDir+"classList.html", ht, out);
    dbStudent s=new dbStudent();
    Parser.parseHtml(templateDir+"classList.html", ht, out,  new RecordParser( s.classList(course),s.classListFields(course)));
 
  }
  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void changePasswordPage (ServletOutputStream out, String unum,String course, 
		      String templateDir)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbStudent.getFields(accesscode);
    Hashtable ht=sys.std_cache.getbyID(unum,course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);



    Parser.parseHtml(templateDir+"password.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // SERVICE
  //--------------------------------------------------------------------//  
  void changePassword (ServletOutputStream out, String unum,String course, String gspwd,
		      String templateFile)        
       throws  Exception, IOException
  {
    dbStudent s=sys.std_cache.getbyID(unum,course);
    s.fields.put("gspwd",gspwd);
    s.setIdentification();
    //	dbu.update();
    sys.std_cache.update(s);
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    Parser.parseHtml(templateFile,ht , out);

  }
  //--------------------------------------------------------------------//
  // SERVICE: SURVEY:surveyMenu
  //--------------------------------------------------------------------//  
  void surveyMenu(ServletOutputStream out, String unum,String course, String templateDir)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      dbSurvey s=new dbSurvey();
      String fieldNames = "surveyname";
      String queryProjection = "DISTINCT surveyname";
      ResultSet rs = s.records(queryProjection,"course='"+course+"'","");
     Parser.parseHtml(templateDir+"survey/surveyMenu.html",ht , out, new RecordParser(rs, fieldNames));
  }

  //--------------------------------------------------------------------//
  // SERVICE: SURVEY:
  //--------------------------------------------------------------------//  
  void surveyPage(ServletOutputStream out, String unum,String course, String templateFile,String surveyname)
       throws Exception, IOException 
  {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    if (surveyname==null) 
      throw new Exception("Please select an existing  survey first!");
    ht.put("surveyname",surveyname);
    dbSurvey s=new dbSurvey();
    Parser.parseHtml(templateFile, ht, out,  new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)    ));

  }

  //--------------------------------------------------------------------//
  // SERVICE: SURVEY:
  //--------------------------------------------------------------------//  
  void  storeSurvey(ServletOutputStream out, String unum,String course, String templateFile,String surveyname,String survey)       throws Exception, IOException 
  {
     //System.out.println("survey====="+survey);
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    dbSurvey s=new dbSurvey();
    String accesscode= sys.std_cache.findAccessNumber(unum);
    s.saveSurvey(accesscode,course,surveyname,survey);
    Parser.parseHtml(templateFile,ht , out);
     //System.out.println("survey====="+survey);
  }

  void systemSettings(ServletOutputStream out, String unum,String templateFile,HttpServletRequest req)       throws Exception, IOException 
  {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    Configuration.setConfiguration(req);
   
     
   Parser.parseHtml(templateFile,ht , out);
  }




} //class close

